{ UsaPoly.pas  v2.0 Copyright 5/94    Adolfo Di Mare }

{$I ADT-ADH.inc}

PROGRAM UsePoly;
{ RESULTADO
  Permite realizar operaciones con polinomios. }
{ METODO
  Se almacena el polinomio en el tipo abstracto de datos
  TPoly, y se utiliza la unidad Poly_T para realizar
  las operaciones. }

{ PROGRAMADOR          ADH ==> Adolfo Di Mare }

USES
  Crt, Test, Poly;

VAR
  p,   { Polinomios con que se opera }
  q,
  r : TPoly;

{$F+} { fuerza llamados lejanos activada }

PROCEDURE Despliega_Polys;
{ RESULTADO
  Despliega el valor de las dos variables p y q }
BEGIN { Despliega_Polys }
  WriteLn('p = ', p.To_STRING);
  WriteLn('q = ', q.To_STRING);
END;  { Despliega_Polys }

PROCEDURE Welcome;
{ RESULATDO
  Presenta el programa }
BEGIN { Welcome }
  ClrScr;

  p.Init;
  q.Init;
  r.Init;

  p.SetTerm(1.49990, 1);
  p.SetTerm(-1.0, 0);

  q.SetTerm(1.0, 1);
  q.SetTerm(1.0, 0);

END;  { Welcome }

PROCEDURE GoodBye;
{ RESULTADO
  Despide el programa }
BEGIN { GoodBye; }
  ClrScr;
  WriteXY(10,10, 'Fin de la prueba del ADT polinomio');

  WriteLn;
  Despliega_Polys;

  r.Done;
  q.Done;
  p.Done;

END;  { GoodBye; }

PROCEDURE Before;
{ RESULTADO
  Da un mensaje cuando que se va a entrar al men }
BEGIN { Before }
  ClrScr;
  WriteLn;
  WriteLn;
  Despliega_Polys;
END;  { Before }

PROCEDURE Inter;
{ RESULTADO
  Borra la pantalla y escribe la lista al derecho y al revs
  despus de seleccionada la opcin del men pero antes de
  ejecutarla.                                               }
BEGIN { Inter }
  ClrScr;
  WriteLn;
  WriteLn;
  Despliega_Polys;
END;  { Inter }

PROCEDURE After;
{ RESULTADO
  Avisa que se ha salido del men. }
BEGIN { After }
  ClrScr;
  WriteLn('Se ha salido del men y de ejecutar una opcin');
  Despliega_Polys;
END;  { After }

PROCEDURE Set_p_A;
{ RESULTADO
  Hace p = x^2+x }
VAR
  pTmp : TPoly;
BEGIN { Set_p_A }
  pTmp.Init;
  pTmp.Clear;

  pTmp.SetTerm(1.0, 2); { x^2 }
  pTmp.SetTerm(1.0, 1); { x^1 }

  IF Display THEN BEGIN
    Say('p = '+ pTmp.To_STRING);
  END
  ELSE BEGIN
    p.Copy(pTmp);
  END;

  pTmp.Done;
END;  { Set_p_A }

PROCEDURE Set_q_A;
{ RESULTADO
  Hace p = x^3-2x^2+1 }
VAR
  pTmp : TPoly;
BEGIN { Set_q_A }
  pTmp.Init;

  pTmp.SetTerm(  1.0, 3);  {   x^3 }
  pTmp.SetTerm( -2.0, 2);  { -2x^2 }
  pTmp.SetTerm(  1.0, 0);  {     1 }

  IF Display THEN BEGIN
    Say('p = '+ pTmp.To_STRING);
  END
  ELSE BEGIN
    p.Copy(pTmp);
  END;

  pTmp.Done;
END;  { Set_q_A }

PROCEDURE Set_pq;
{ RESULTADO
  Hace p = x-1  q = x+1 }
VAR
  pTmp,qTmp : TPoly;
BEGIN { Set_pq }
  pTmp.Init;
  qTmp.Init;

  pTmp.SetTerm(1.0, 1);
  pTmp.SetTerm(-1.0, 0);

  qTmp.SetTerm(1.0, 1);
  qTmp.SetTerm(1.0, 0);

  IF Display THEN BEGIN
    Say('p = '+ pTmp.To_STRING + '  ' +
        'q = '+ qTmp.To_STRING);
  END
  ELSE BEGIN
    p.Copy(pTmp);
    q.Copy(qTmp);
  END;

  qTmp.Done;
  pTmp.Done;
END;  { Set_pq }

PROCEDURE Set_q_B;
{ RESULTADO
  Hace q = 11x^3-2 }
VAR
  pTmp : TPoly;
BEGIN { Set_q_B }
  pTmp.Init;
  pTmp.Clear;
{
  pTmp.SetTerm(-11.0, 3);
  pTmp.SetTerm(-2.0, 2);
}
  pTmp.SetTerm( 11.0, 3);
  pTmp.SetTerm( -2.0, 0);

  IF Display THEN BEGIN
    Say('q = '+ pTmp.To_STRING);
  END
  ELSE BEGIN
    q.Copy(pTmp);
  END;

  pTmp.Done;
END;  { Set_q_B }

PROCEDURE Leer_Poly(
  {-} VAR poly : TPoly  { polinomio a almacenar   }
);
{ RESULTADO
  Almacena en "poly" un polinomio                    }
VAR
   coef  : REAL;
   exp   : WORD;
   q : TPoly;
BEGIN  { Leer_Poly }
  WriteLn;
  WriteLn(
    'El polinomio se debe digitar trmino por trmino ',
    '(coef, exp)');
  WriteLn('Para terminar digite en COEFICIENTE un "0"');
  WriteLn;
  WriteLn;
  Write('COEFICIENTE : ');
  ReadLn(coef);
  WHILE coef <> 0 DO BEGIN
    REPEAT
      ClrEol;
      Write('EXPONENTE  : ');
      Read(exp);
    UNTIL (exp <= Max_Grado) AND (exp >= 0);

    WriteLn;
    poly.SetTerm(coef, exp);
    Write('COEFICIENTE : ');
    ReadLn(coef);
  END;
END;  { Leer_Poly }

PROCEDURE Leer_p;
{ RESULTADO
  Lee el valor del primer polinomio }
BEGIN { Leer_p }
  IF Display THEN BEGIN
    Say('Leer el valor de p');
    EXIT;
  END;

  ClrScr;
  Write('Digite el valor del polinomio');
  Leer_Poly(p);
  Despliega_Polys;
END;  { Leer_p }

PROCEDURE Leer_q;
{ RESULTADO
  Lee el valor del segundo polinomio }
BEGIN { Leer_q }
  IF Display THEN BEGIN
    Say('Leer el valor de q');
    EXIT;
  END;

  ClrScr;
  Write('Digite el valor del polinomio');
  Leer_Poly(q);
  Despliega_Polys;
END;  { Leer_q }

PROCEDURE Add_Poly;
{ RESULTADO
  Lee dos polinomios y los suma. }
BEGIN { Add_Poly }
  IF Display THEN BEGIN
    Say('p+q:     Suma');
    EXIT;
  END;
  r.Copy(p);
  r.Add(q);
  WriteLn;
  WriteLn('Suma = ', r.To_STRING);
  KeyDelay(5);
END;  { Add_Poly }

PROCEDURE Sub_Poly;
{ RESULTADO
  Lee dos polinomios y los resta. }
BEGIN { Sub_Poly }
  IF Display THEN BEGIN
    Say('p-q:     Resta');
    EXIT;
  END;

  r.Copy(p);
  r.Substract(q);
  WriteLn;
  WriteLn('Resta = ', r.To_STRING);
  KeyDelay(5);
END;  { Sub_Poly }

PROCEDURE Mult_Poly;
{ RESULTADO
  Lee dos nmero reales y los multiplica }
BEGIN { Mult_Poly }
  IF Display THEN BEGIN
    Say('p*q:     Multiplicacin');
    EXIT;
  END;

  r.Copy(p);
  r.Multiply(q);
  WriteLn;
  WriteLn('Multiplicacin = ', r.To_STRING);
  KeyDelay(5);
END;  { Mult_Poly }

PROCEDURE Div_Poly;
{ RESULTADO
  Lee dos polinomios y los divide. }
VAR
  x, y : REAL;
BEGIN { Div_Poly }
  IF Display THEN BEGIN
    Say('p DIV q: Divisin');
    EXIT;
  END;
  ClrScr;

  IF q.Is_Zero THEN BEGIN
    BOOM(18,7);
    WriteXY(23,17, 'Es invlido dividir por cero!');
  END
  ELSE BEGIN
    r.Copy(p);
    r.Divide(q);
    WriteLn;
    WriteLn('Divisin = ', r.To_STRING);
  END;

  KeyDelay(5);
END;  { Div_Poly }

PROCEDURE Mod_Poly;
{ RESULTADO
  Lee dos polinomios y deja el residuo de su divisin. }
VAR
  x, y : REAL;
BEGIN { Mod_Poly }
  IF Display THEN BEGIN
    Say('p MOD q: Mdulo');
    EXIT;
  END;
  ClrScr;

  IF q.Is_Zero THEN BEGIN
    BOOM(18,7);
    WriteXY(23,17, 'Es invlido dividir por cero!');
  END
  ELSE BEGIN
    r.Copy(p);
    IF NOT r.Equal(p) THEN BEGIN
      WriteLn('ERROR');
    END;
    r.Modulo(q);
    WriteLn;
    WriteLn('Mdulo = ', r.To_STRING);
  END;

  KeyDelay(5);
END;  { Mod_Poly }

PROCEDURE Minus_Poly;
{ RESULTADO
  Lee un polinomio y determina su complemento. }
BEGIN { Minus_Poly }
  IF Display THEN BEGIN
    Say('-p:      Complemento');
    EXIT;
  END;

  r.Copy(p);
  r.Minus;
  WriteLn;
  WriteLn('-p = ', r.To_STRING);

  r.Copy(q);
  r.Minus;
  WriteLn('-q = ', r.To_STRING);
  WriteLn;

  KeyDelay(5);
END;  { Minus_Poly }

PROCEDURE Equal_Poly;
{ RESULTADO
  Compara los dos polinomios. }
BEGIN { Equal_Poly }
  IF Display THEN BEGIN
    Say('p=q:     Comparacin');
    EXIT;
  END;
  ClrScr;
  Despliega_Polys;
  IF p.Equal(q) THEN BEGIN
    WriteLn('Los dos polinomios son iguales');
  END
  ELSE BEGIN
    WriteLn('Los dos polinomios NO son iguales');
  END;

  KeyDelay(5);
END;  { Eval_Poly }

PROCEDURE Eval_Poly;
{ RESULTADO
  Compara los dos polinomios. }
VAR
  i : WORD;
  r : REAL;
BEGIN { Eval_Poly }
  IF Display THEN BEGIN
    Say('Evala los dos polinomios');
    EXIT;
  END;

  ClrScr;
  Despliega_Polys;

  WriteLn;
  WriteLn;
  FOR i := 0 TO 5 DO BEGIN
    Write('':10, 'p(', i:1, ') = ', p.Eval(i):8:2);

    Write('':10, 'q(', i:1, ') = ', q.Eval(i):8:2);
    WriteLn;
  END;

  KeyDelay(5);
END;  { Eval_Poly }

PROCEDURE Expo_Poly;
{ RESULTADO
  Determina un coeficiente del polinomio. }
VAR
  exp : WORD;
BEGIN { Expo_Poly }
  IF Display THEN BEGIN
    Say('Coeficiente de p');
    EXIT;
  END;

  ClrScr;
  WriteLn('Polinomio en uso: ', p.To_STRING);
  WriteLn;
  Writeln(
    'Digite el exponente del trmino para ',
    'obtener el coeficiente ');
  REPEAT
    ClrEol;
    Write('EXPONENTE    : ');
    Read(exp);
  UNTIL exp >= 0;
  WriteLn;
  Write('El coeficiente del trmino de exponente ',exp,' es: ');
  Write(p.Coef(exp):6:2);

  KeyDelay(5);
END;  { Expo_Poly }

PROCEDURE Grado_Poly;
{ RESULTADO
  Determina el grado del polinomio. }
BEGIN { Grado_Poly }
  IF Display THEN BEGIN
    Say('Grados de los polinomios');
    EXIT;
  END;

  ClrScr;
  WriteLn('p:     ', p.To_STRING);
  WriteLn('Grado: ', p.Degree);

  WriteLn;
  WriteLn;

  WriteLn('q:     ', q.To_STRING);
  WriteLn('Grado: ', q.Degree);

  KeyDelay(5);
END;  { Grado_Poly }

{$F-} { fuerza para llamados lejanos activada }

BEGIN { UsePoly }

  { define los procedimiento para Test.pas }
  First_Proc(Welcome);
  Last_Proc(GoodBye);

  Pre_Menu(Before);
  Inter_Menu(Inter);
  Post_Menu(After);

  Title('Prueba del ADT Polinomio', 6, Sngl_Line);

  Add_Option(Leer_p);
  Add_Option(Leer_q);
  Add_Option(Set_p_A);
  Add_Option(Set_q_A);
  Add_Option(Set_q_B);
  Add_Option(Set_pq);
  Add_Option(Minus_Poly);
  Add_Option(Add_Poly);
  Add_Option(Sub_Poly);
  Add_Option(Mult_Poly);
  Add_Option(Div_Poly);
  Add_Option(Mod_Poly);
  Add_Option(Equal_Poly);
  Add_Option(Eval_Poly);
  Add_Option(Expo_Poly);
  Add_Option(Grado_Poly);

{ Force_Option(Eval_Poly, 1); }

  GoWork;

END.  { UsePoly }

{ EOF: UsePoly.pas }
